#!/usr/bin/env python
# encoding=utf8

import argparse
import os,re,sys,subprocess,csv
reload(sys)  
sys.setdefaultencoding('utf8')

parser = argparse.ArgumentParser()
parser.add_argument("--autonomous", "-a",  action="store_true", help="display autonomous systems numbers instead of company names")
parser.add_argument('destination', metavar='dest', help='the destination to trace to', type=str)
parser.add_argument('--caida','-c', action='store_true', help='switch to csv format')
parser.add_argument('--lft','-l', action='store_true', help='uses lft instead of traceroute to traceroute..')

args = parser.parse_args()

dest = args.destination
destinations=[]
listnodes=[]

if args.lft:
	trace = subprocess.check_output(['lft', '-pSA', dest])
else:
	trace = subprocess.check_output(['traceroute', '-a', dest])

trace = trace.decode("utf-8")

# executes a traceroute using lft , which returns a list of Autonomous System numbers
AS = []
for i in trace.splitlines():
	if i.startswith('TTL'):
		pass
	else:
		if not i.startswith('**'):
			try:
				if args.lft:
					i=i.split('[')[1].split(']')[0]
				else:
					i=i.split('[AS')[1].split(']')[0]
					if ('/AS') in i:
						i=i.split('/AS')[1]
				if (i not in AS) and (not i == 'AS?'):
					AS.append(i)
			except:
				pass


listnodes=[]
# for each of the autonomous systems numbers, preforms a whois to obtain their name, except with the --caida switch
for asss in AS:
	if args.autonomous != True:
		if not asss == 'AS?':
			process = subprocess.Popen(['whois', 'AS'+asss], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
			aswho, err = process.communicate()
			for line in aswho.splitlines():
				if ("OrgName" in line) or ('org-name' in line):
					a = line.split()[1:]
		#			print asss+' is '+' '.join(a)
					listnodes.append(' '.join(a))
	else:
		listnodes.append(asss)

# if its launcehd with the -c or --caida switch, it returns a list of numbers, otherwise a list of names
if args.caida:
	print (','.join(listnodes))
else:
	text=' ( '+' → '.join(listnodes)+' )'
	print text

